#include "suh.h"
#include "auxilary.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


struct one_parameter
{
	char name[31];
	int no_check;
	double low_bound;
	double high_bound;
};

struct the_distribution
{
	char name[31];
	int max_which;
	int nparam;
	one_parameter parameters[6];
};



double bdf;
double bpnonc;
double immense;
double large;
double r_immense;
double sdf;
double spnonc;
double sprob;
double bprob;


void init_constants()
{
	bdf=pow(10,10);
	bpnonc=pow(10,4);
	immense=pow(10,100);
	large=pow(10,10);
	r_immense=pow(1,-100);
	sdf=pow(10,-3);
	spnonc=0;
	sprob=pow(10,-10);
	bprob=1-sprob;
}


void check_complements(int options,double *cum, double *ccum, double *local_x, double *local_y,int set_value,int badstatus,int *status)
{
	int count=0;
	if(options&1)
		count++;
	if(options&2)
		count++;
	switch(count)
	{
		case 0:
			*status=badstatus;
			printf("you must have at least one arguement(cum,ccum) to check_complements\n");
		
			break;
		case 1:
			if(!set_value) return;
			if(options&1)	// if cum is present
			{
				*local_x=*cum;
				*local_y=1-*cum;
			}
			else
			{
				*local_y=*ccum;
				*local_x=1-*ccum;
			}
			break;
		case 2:
			if(!set_value) return;
			local_x=cum;
			local_y=ccum;
			break;
		default:
			printf("wtf are we doing in the default case of check_complements\n");
			exit(0);
	
	}
}

void validate_parameteres(the_distribution* distrib, int which, double *params, int *status)
{
	char tn1[31]="which";
	char tn2[31];
	int i,nparam;
	nparam=distrib->nparam;
	
	if(! in_range(which, 1, distrib->max_which, distrib->name, tn1, -1, status))
		return;
	if(which!=1)
	{
		strcpy(tn1,"cum");
		strcpy(tn2,"ccum");
		if(!add_to_one(params[0],params[1],distrib->name,tn1,tn2,3,status))
			return;
	}
	for(i=0;i<nparam;i++)
	{
		if(which!=distrib->parameters[i].no_check)
		{
			if(!in_range(params[i], distrib->parameters[i].low_bound, distrib->parameters[i].high_bound, distrib->name, distrib->parameters[i].name,-(i+2),status))
				return;
		}
	}


}
int add_to_one(double x, double y, char *routine_name, char *x_name, char *y_name,	int bad_status, int *status)
{
	int addtoone;
	if(fabs((x+y)-1)>3*nextafter(0,1))
	{
		addtoone=false;
		*status=bad_status;
	}
	else
		addtoone=true;
	return addtoone;
}

int in_range(double value, double low, double high, char *routine_name, char *argname, int bad_status, int* status)
{
	if(value>high || value <low)
	{
		printf("%lf out of range of (%lf-%lf).\n",value, low, high);
		*status=bad_status;
		return false;
	}
	return true;	
}

void cdf_set_zero_finder(the_distribution *distrib, int which)
{
	
}