#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "suh.h"
#include "onedataset.h"
#include "normal.h"


void banner();
void interactiveread();
int checkprogenitors(int numalleles,int *alleles,int *progens);
void **matloc(int x, int y, int cellsize);
void trimdata();
void print_answers();
void quiet_print_answers();
double calculate_Z(double f1, double f2, double se1, double se2);
void initranrot(unsigned int seed);
unsigned int randrot();
int m_high,m_low;   // variables for ranrot


int numruns,numallele;
int *allelesize;
double *expge;
int *replicates;
int **tableofalleles;
int progenitors[2];

_mu mu;
_freq freq;
_mutant mutant;
_calibrate calibrate;
double truefreq[50];

// [est, var, sd, esum, ess][trans, untrans][data, boot][alleles]
//double freq[5][2][2][50];   // this is not very dynamic, but goddamnit it is something



// [init_est, est, var, sd, esum, ess][data,boot][alleles]
//double mu[4][2][50];

// [data,boot,shrink][alleles][runs]
_seen seen;
_seen unseen;

int main (int argc, const char * argv[])
{
	int x,y;
	int testallelesize[3]={88,94,98};
	int testtableofalleles[3][3]={{3,5,3},{66,60,63},{88,55,88}};
	char menuselect;
	double freq1, freq2;
	double stderr1, stderr2;
	double Z;
	double dummy,result;
	initranrot(clock());
	scanf("%c",&menuselect);
	switch(menuselect)
	{
		case '0':   // exit the program
			printf("exiting the program\n");
			exit(0);
			break;
		case '1': // read filemaker format
				
			break;
		case '2': // uses test data
			
/*		
3 2 9 148 150 152 156 158 160 162 164 166
164 166
.75 .75
96 16
1 1 3 3 1 1 3 46 50
0 0 0 0 0 0 0 8 6
y
*/
			//numruns=2;
			numruns=3;
			expge=(double*)malloc(sizeof(double)*numruns);
			replicates=(int*)malloc(sizeof(int)*numruns);
			//numallele=9;
			numallele=3;
			allelesize=(int*)malloc(sizeof(int)*numallele);
			printf("Enter the sizes of the %d alleles:",numallele);
			for(x=0;x<numallele;x++)
				allelesize[x]=testallelesize[x];
			//progenitors[0]=164;
			//progenitors[1]=166;
			progenitors[0]=94;
			progenitors[1]=98;
			expge[0]=.75;
			expge[1]=.75;
			expge[2]=.75;
			//replicates[0]=96;
			//replicates[1]=16;
			replicates[0]=120;
			replicates[1]=120;
			replicates[2]=88;
			tableofalleles= (int**)matloc(numruns,numallele,sizeof(int));
			for(x=0;x<numruns;x++)
			{
				for(y=0;y<numallele;y++)
					tableofalleles[y][x]=testtableofalleles[y][x];  // get data
			}
			printf("your table:\n");
			for(x=0;x<numruns;x++)
			{
				for(y=0;y<numallele;y++)
					printf("%d\t",tableofalleles[y][x]);
				printf("\n");
			}
			trimdata();
			printf("your table after trimming\nallele sizes:\n");
			
			for(x=0;x<numallele;x++)
				printf("%d ",allelesize[x]);
			printf("\n");
			for(x=0;x<numruns;x++)
			{
				for(y=0;y<numallele;y++)
					printf("%d\t",tableofalleles[y][x]);
				printf("\n");
			}
			fitone(false,false,-1);
			bootstrap();
			//fitone(true,false,-1);
			print_answers();
			break;
		case '3': // interactively input data
				interactiveread();
				fitone(false,false,-1);
				bootstrap();
				print_answers();
				// 
			break;
/**********************************************************************
* format for exporting from excel and filemaker
* 1) numruns
* 2) numalleles
* 3) allele sizes (there needs to numallele of them)
* 4) progenitor allele's sizes, there needs to be 2 of them, if
*	 homozygous, repeat it twice
* 5) for each run/row
	 a) obs. ge
	 b) number of replicates
	 c) number of alleles saw at each allele size


**********************************************************************/
		case '4': // read in crazy formatted data
			scanf("%d",&numruns);
			expge=(double*)malloc(sizeof(double)*numruns);
			replicates=(int*)malloc(sizeof(int)*numruns);
			scanf("%d",&numallele);
			allelesize=(int*)malloc(sizeof(int)*numallele);
			for(x=0;x<numallele;x++)
				scanf("%d",&allelesize[x]);
			for(x=0;x<2;x++)
				scanf("%d",&progenitors[x]);
			tableofalleles= (int**)matloc(numruns,numallele,sizeof(int));
			for(y=0;y<numruns;y++)
			{
				scanf("%lf",&expge[y]);
				scanf("%d",&replicates[y]);
				for(x=0;x<numallele;x++)
					scanf("%d",&tableofalleles[x][y]);
			}
			trimdata();
			fitone(false, false, -1);
			bootstrap();
			quiet_print_answers();
			break;
		case '5':		// calculate the significance between 2 mutation frequencies.
			scanf("%lf",&freq1);
			scanf("%lf",&freq2);
			scanf("%lf",&stderr1);
			scanf("%lf",&stderr2);
			Z=calculate_Z(freq1,freq2,stderr1,stderr2);
			cumnor(&Z,&result,&dummy);
			printf("%E\n",result);
			break;
		case '6':
			printf("Enter the first mutant frequency: ");
			scanf("%lf",&freq1);
			printf("Enter the second mutant frequency: ");
			scanf("%lf",&freq2);
			printf("Enter the first standard error: ");
			scanf("%lf",&stderr1);
			printf("Enter the second standard error: ");
			scanf("%lf",&stderr2);
			Z=calculate_Z(freq1,freq2,stderr1,stderr2);
			cumnor(&Z,&result,&dummy);
			printf("Z = %lf\n",Z);
			//printf("significance = %E\n",normal(Z));
			printf("significance = %E\n",result);
			break;
		case '7': // like case 4, but verbose
			scanf("%d",&numruns);
			expge=(double*)malloc(sizeof(double)*numruns);
			replicates=(int*)malloc(sizeof(int)*numruns);
			scanf("%d",&numallele);
			allelesize=(int*)malloc(sizeof(int)*numallele);
			for(x=0;x<numallele;x++)
				scanf("%d",&allelesize[x]);
			for(x=0;x<2;x++)
				scanf("%d",&progenitors[x]);
			tableofalleles= (int**)matloc(numruns,numallele,sizeof(int));
			for(y=0;y<numruns;y++)
			{
				scanf("%lf",&expge[y]);
				scanf("%d",&replicates[y]);
				for(x=0;x<numallele;x++)
					scanf("%d",&tableofalleles[x][y]);
			}
			trimdata();
			fitone(false, false, -1);
			bootstrap();
			print_answers();
			break;	
			
		default:
			printf("got an illegal menuselection and now exiting\n");
		
	}
	
    return 0;
}

void banner()
{
	printf("%s\n%s\n\n%s\n%s\n\n%s\n",
	"                             SPPCR",
	"                     Version 2.0: July 2004",
	"                 Estimates Allele Frequencies from",
	"                    Small Pool PCR Experiments",
	"                     Ported by Brian Ramagli");
}

void interactiveread()
{
	char correct;
	int x,y,sum;
	
	printf("%s\n\n%s\n\n%s\n\n%s\n\n\n%s",
	"GENERAL INFORMATION ON INTERACTIVE DATA ENTRY:",
	"RUNS: A run  consists of a number  of  wells examined at a  particular genome equivalent  amount of  dna.   Different runs can have  the same amount of dna, but this is unusual.",
	"ALLELES: Alleles are  identified through integer  numbers that we term size.  The size is only the label for the allele -- it is not used in any calculation.",
	"GENERAL: Lists of numbers can be entered on several lines (the program keeps reading until it has enough numbers then quits reading.  Numbers themselves cannot span lines.  Thus 123 CANNOT be written as 1 at the end of a line and 23 at the beginning of the next line.",
	"Enter the number of runs (number of dna amounts):");
	scanf("%d",&numruns);
	expge=(double*)malloc(sizeof(double)*numruns);
	replicates=(int*)malloc(sizeof(int)*numruns);
	printf("Enter the number of alleles seen:");
	scanf("%d",&numallele);
	allelesize=(int*)malloc(sizeof(int)*numallele);
	printf("Enter the sizes of the %d alleles:",numallele);
	for(x=0;x<numallele;x++)
		scanf("%d",&allelesize[x]);
lblenterprogenitors:
	printf("Enter the size of the 2 progenitor alleles. If the subject is homozygous, enter the size of the 1 progenitor twice.");
	for(x=0;x<2;x++)
		scanf("%d",&progenitors[x]);
	if(!checkprogenitors(numallele,allelesize,progenitors))
	{
		printf("progenitor allele size does not appear in the list of allele sizes. Reenter progenitor sizes.\n");
		goto lblenterprogenitors;
	}
	printf("For each run, enter the expected genomes.\n");
	for(x=0;x<numruns;x++)
	{
		printf("Expected ge for run %d:",x+1);
		scanf("%lf",&expge[x]);
		if(expge[x]<.001)
		{
			printf("expected ge of %lf is less than the tolerance of .001. Re enter please.\n",expge[x]);
			x--;
			continue;
		}
		if(expge[x]>1000)
		{
			printf("expected ge of %lf is greater than the tolerance of 1000. Re enter please.\n",expge[x]);
			x--;
			continue;
		}
	}
	printf("For each run, enter the number of replicates.\n");
	for(x=0;x<numruns;x++)
	{
		printf("Replicates for run %d:",x+1);
		scanf("%d",&replicates[x]);
	}
	printf("now enter the number of of times each allele was seen for each run\n");
	printf("alleles sizes: ");
	for(x=0;x<numallele;x++)
		printf("%d ",allelesize[x]);
	printf("\n");
	
	tableofalleles= (int**)matloc(numruns,numallele,sizeof(int));
lbl_reentertable:
	for(x=0;x<numruns;x++)
	{
		printf("alleles seen for run %d:",x+1);
		for(y=0;y<numallele;y++)
			scanf("%d",&tableofalleles[y][x]);  // get data
		sum=0;
		/*for(y=0;y<numallele;y++)				// now test to make sure 
		if(tableofalleles[y][x]>replicates[x])
		{
			printf("seeing more alleles than replicates\nreenter ");
			x--; continue;
		}*/
	}
	printf("your table:\n");
	for(x=0;x<numruns;x++)
	{
		for(y=0;y<numallele;y++)
			printf("%d\t",tableofalleles[y][x]);
		printf("\n");
	}
	printf("is this correct? (y/n) ");
	scanf("%c",&correct);
	scanf("%c",&correct);
	if(correct=='n')
	{
		printf("reenter data\n");
		for(x=0;x<numallele;x++)
			printf("%d ",allelesize[x]);
		printf("\n");
		goto lbl_reentertable;
	}
	trimdata();
	//printf("your table after trimming\nallele sizes:\n");
	
	//for(x=0;x<numallele;x++)
	//	printf("%d ",allelesize[x]);
	//printf("\n");
	//for(x=0;x<numruns;x++)
	//{
	//	for(y=0;y<numallele;y++)
	//		printf("%d\t",tableofalleles[y][x]);
	//	printf("\n");
	//}
	
	
	
}

int checkprogenitors(int numalleles,int *alleles,int *progens)
{
	int x;
	char p1true,p2true;
	p1true=p2true=0;
	for(x=0;x<numalleles;x++)
	{
		if(alleles[x]==progens[0])
			p1true=1;
		if(alleles[x]==progens[1])
			p2true=1;
	}
	return p1true && p2true;
}


void **matloc(int x, int y, int cellsize)
{
  void **matt; int bob,joe;
  if (!(matt = (void**)malloc(y*sizeof(void**)))) return 0;
  for(bob=0;bob<y;bob++)
    if (!(matt[bob] = malloc(x*cellsize)))
    {
      for(joe=0;joe<bob;joe++) free(matt[joe]);
      free(matt);
      return 0;
    }
  return matt;
}

void trimdata()
{
	int x,y,i;
	int sum,tempnumalleles;
	int **temptable;
	int *markedrows,*temparr;
	markedrows=(int*)malloc(sizeof(int)*numallele);
	for(x=0;x<numallele;x++)
		markedrows[x]=1;	// rows marked 1 are in, 0s are out
	// eliminate rows where no alleles were seen
	tempnumalleles=0;
	for(x=0;x<numallele;x++)
	{
		sum=0;
		for(y=0;y<numruns;y++)
			sum+=tableofalleles[x][y];
		if(sum==0 && (allelesize[x]!=progenitors[0] && allelesize[x]!=progenitors[1]))  // nothing seen in that row, do not delete columns that are progenitor as per request of mary
			markedrows[x]=0;
		else tempnumalleles++;
	}
	//printf("table marked\n");
	temptable= (int**)matloc(numruns,tempnumalleles,sizeof(int));
	for(x=0,i=0;x<numallele;x++)
	{
		if(markedrows[x]==1)
		{
			for(y=0;y<numruns;y++)
				temptable[i][y]=tableofalleles[x][y];
		
		i++;
		}
	}
	// table is now resized, now to resize the allele array
	temparr=(int*)malloc(sizeof(int)*tempnumalleles);
	for(x=0,i=0;x<numallele;x++)
	{
		if(markedrows[x]==1)
		{
			temparr[i]=allelesize[x];
			i++;
		}
		
	}
	free(allelesize);
	free(tableofalleles);
	tableofalleles=temptable;
	numallele=tempnumalleles;
	allelesize=temparr;
	
	// change dna from g.e. to allele equivalent.
	for(x=0;x<numruns;x++)
		expge[x]*=2.0;
			


	// change progenitor to use allele index?
	for(x=0;x<numallele;x++)
	{
		if(allelesize[x]==progenitors[0])
			progenitors[0]=x;
		if(allelesize[x]==progenitors[1])
			progenitors[1]=x;
	}
	
	for(x=0;x<numruns;x++)
	{
		for(y=0;y<numallele;y++)
			seen.data[y][x]=tableofalleles[y][x];
	}
	
	for(x=0;x<numruns;x++)
	{
		for(y=0;y<numallele;y++)
			unseen.data[y][x]=replicates[x]- seen.data[y][x];
	}
	/*printf("seen				      unseen\n");
	for(x=0;x<numruns;x++)
	{
		for(y=0;y<numallele;y++)
		{
			printf("%lf ",seen.data[y][x]);
		}
		printf("  ");
		for(y=0;y<numallele;y++)
		{
			printf("%lf ",unseen.data[y][x]);
		}
		
		printf("\n");
	}*/
		
	
}

void print_answers()
{
	int x;
	double normal_975 =  1.959964;
	double low_bnd= calibrate.est.data - normal_975*calibrate.sd.boot;
	double hi_bnd= calibrate.est.data + normal_975*calibrate.sd.boot;

	
	// bring ge from allele equiv to ge
	for(x=0;x<numruns;x++)
		expge[x]/=2.0;
	/*
	printf("\n");
	printf("%s\n%s\n%s\n\n",
			"allele  initial    final          mean          asymptotic  bootstrap",
			"size    estimate   estimate       bootstrap     standard    standard",
			"                                  estimate      error       error");
	for(x=0;x<numallele;x++)
	{
		printf("%d\t\t%lf\t\t%lf\t\t%lf\t\t%lf\t\t%lf",allelesize[x], mu.init_est.data[x], mu.est.data[x],freq.est.untrans.boot[x],freq.sd.untrans.data[x],freq.var.untrans.boot[x]);
		printf("\n");
	}
	*/
	printf("d0 = %.4lf\n95%% CI (%.4lf,%.4lf)\n", 1.0/calibrate.est.data,1/hi_bnd,1/low_bnd);
	printf("1/d0 = %.4lf\n95%% CI (%.4lf,%.4lf)\n", calibrate.est.data,low_bnd,hi_bnd);
	for(x=0;x<numruns;x++)
	{
		if(progenitors[0]!=progenitors[1])
			printf("estimated ge for run %d = %.4lf\n", x, expge[x]*calibrate.est.data);
		else
			printf("estimated ge for run %d = %.4lf\n", x, expge[x]*calibrate.est.data);	// do not multiply 2
	}
	
	for(x=0;x<30;x++)
		printf("*");
	printf("\nMutant Frequency\n");
	
	low_bnd=inverse_arcsin(mutant.est.trans.data-normal_975*mutant.sd.trans.boot);
	hi_bnd=inverse_arcsin(mutant.est.trans.data+normal_975*mutant.sd.trans.boot);
	
	
	//printf("untransformed\n");
	printf("estimate: %lf\n",mutant.est.trans.data);
	printf("CI(%.4lf,%.4lf)\n",mutant.est.trans.data-normal_975*mutant.sd.trans.boot,mutant.est.trans.data+normal_975*mutant.sd.trans.boot);
	//printf("asymptotic SE: %lf\n",mutant.sd.trans.data);
	//printf("mean bootstrap estimate: %lf\n",mutant.est.trans.boot);
	printf("bootsrap SE: %lf\n",mutant.sd.trans.boot);
	//printf("bootstrap estimate: %lf",
	

}

// less verbose than normal print answers
void quiet_print_answers()
{
	int x;
	double normal_975 =  1.959964;
	double low_bnd= calibrate.est.data - normal_975*calibrate.sd.boot;
	double hi_bnd= calibrate.est.data + normal_975*calibrate.sd.boot;
	
	// bring ge from allele equiv to ge
	for(x=0;x<numruns;x++)
		expge[x]/=2.0;
	// GEs per run
	for(x=0;x<numruns;x++)
	{
			printf("%.4lf\n",expge[x]*calibrate.est.data);
	}
	low_bnd=inverse_arcsin(mutant.est.trans.data-normal_975*mutant.sd.trans.boot);
	hi_bnd=inverse_arcsin(mutant.est.trans.data+normal_975*mutant.sd.trans.boot);
	// Mutant Frequency
	printf("%lf\n",mutant.est.trans.data);
	// Bootstrap SE
	printf("%lf\n",mutant.sd.trans.boot);
	

}




void initranrot(unsigned int seed)
{
	m_low = seed;
	m_high = ~seed;
}
unsigned int randrot()
{
	m_high = (m_high<<16) + (m_high>>16);
	m_high += m_low;
	m_low += m_high;
	return m_high;

}

double calculate_Z(double f1, double f2, double se1, double se2)
{
	//printf("- | %lf - %lf | = - | %lf | = %lf\n",f1,f2,f1-f2, -fabs(f1-f2));
	//printf("‚àö(%E^2 + %E^2 = ‚àö(%E + %E) = ‚àö(%E) = %E\n",se1,se2, se1*se1, se2*se2,se1*se1 + se2*se2,sqrt(se1*se1 + se2*se2) );
	return (-fabs(f1-f2))/sqrt(se1*se1 + se2*se2);
}