#include <stdio.h>
#include <stdlib.h>
#include "randombinomial.h"
#include <sys/time.h>

int m_high,m_low; 

void initranrot(unsigned int seed)
{
	m_low = seed;
	m_high = ~seed;
}
unsigned int randrot()
{
	m_high = (m_high<<16) + (m_high>>16);
	m_high += m_low;
	m_low += m_high;
	return m_high;

}


int main()
{
	int x;
	int temp;
	int *distrib;
	double trials=96;
	int runs=100000;
	distrib=(int*)malloc(sizeof(int)*(trials+1));
	double prob=0.0;
	initranrot(time(NULL));
	printf("randmax=%d\n",RAND_MAX);
	for(x=0;x<trials+1;x++)
		distrib[x]=0;
	for(x=0;x<runs;x++)
	{
		temp=random_binomial(trials,prob);
		distrib[temp]++;
	}
	printf("randombinomial\ntrials: %lf\nprobability: %lf\nruns: %d\n",trials,prob,runs);
	for(x=0;x<trials+1;x++)
		printf("[%d] %d\n",x,distrib[x]);
	printf("done\n");

	return 0;
}
